<?php

  require $this->app_file("data/pz_sgbd.php");
  require $this->app_file("data/pz_data.php");
  if($this->app_file_exists("data/impl/pz_".$this->bdd("sgbd").".php"))
  { require $this->app_file("data/impl/pz_".$this->bdd("sgbd").".php");
    if(class_exists($sgbd_impl = "pz_".$this->bdd("sgbd")))
    { try
      { $this->env->data = new pz_data
        ( new pz_sgbd
          ( new $sgbd_impl
            ( $this->bdd("host"),
              $this->bdd("base"),
              $this->bdd("user"),
              $this->bdd("password")
            ),
            $this
          ),
          $this
        );
        $this->env->data->load_modules($this->path("app").$this->path("current_app")."data/modules/", true);
        if($this->path("current_app") != $this->path("core_app"))
        { $this->env->data->load_modules($this->path("app").$this->path("core_app")."data/modules/", true);
        }
      }
      catch(Exception $_e) { $this->erreur($_e->getMessage(), true); }
    }
    else $this->erreur("Impossible de trouver la classe d'implementation du sgbd ".$this->bdd("sgbd"), true);
  }
  else $this->erreur("Impossible de trouver le fichier d'implementation du sgbd ".$this->bdd("sgbd"), true);

?>