<?php

  class pz_users_groupes extends pz_mod
  {

    protected $groupe;

    public function validate()
    { if($this->env->user)
      { if($this->env->etat["action"] == "edit" || $this->env->etat["action"] == "del")
        { if(($this->groupe = $this->env->data->groupe($_GET[$this->env->param("id")])) !== false && $this->groupe)
          { if($this->groupe["id_user"] == $this->env->user["id"])
            { return true;
            }
            else return "Vous n'est pas autoris&eacute; &agrave; modifier ce groupe";
          }
          else return "Impossible de lire les informations du groupe";
        }
        else return true;
      }
      return "Vous devez &ecirc;tre identifier pour acc&eacute;der &agrave; cette page";
    }

    function index()
    { if(($this->env->out["groupes"] = $this->env->data->groupes($this->env->user["id"])) !== false)
      {
      }
      else $this->env->erreur("Impossible de lire la liste des groupes");
    }

    function add()
    { if($this->env->data->check_user_uploads_dir())
      { $web_path = $this->env->path("web");
        $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$this->env->path("content")."uploads/".$this->env->user["id"];
        if($_POST)
        { $this->env->out["groupe"] = $_POST;
          if(trim($_POST["nom"]))
          { if(($exists = $this->env->data->groupe_exists($_POST["nom"])) !== false)
            { if($exists == 0)
              { if
                ( $this->env->data->add_groupe
                  ( $this->env->user["id"],
                    $_POST["nom"],
                    $_POST["description"]
                  )
                ) $this->env->redirect
                ( $this->env->url("users/groupes"),
                  "le groupe a &eacute;t&eacute; ajout&eacute;"
                );
                else $this->env->erreur("Impossible d'ajouter le groupe");
              }
              else $this->env->message("Un groupe avec ce nom existe d&eacute;j&agrave;");
            }
            else $this->env->erreur("Impossible de savoir si le groupe existe d&eacute;j&agrave;");
          }
          else $this->env->message("merci de pr&eacute;ciser un nom pour le groupe");
        }
      }
      else $this->env->erreur("Impossible de creer le repertoire utilisateur");
    }

    function edit()
    { if($this->env->data->check_user_uploads_dir())
      { $web_path = $this->env->path("web");
        $_SESSION["upload_dir"] = $web_path.($web_path ? "" : "/").$this->env->path("content")."uploads/".$this->env->user["id"];
        if($this->env->out["groupe"] = $this->groupe)
        { if($_POST)
          { $id = $this->env->out["groupe"]["id"];
            $nom = $this->env->out["groupe"]["nom"];
            $this->env->out["groupe"] = $_POST;
            if(trim($_POST["nom"]))
            { if(($exists = $this->env->data->groupe_exists($_POST["nom"])) !== false)
              { if($exists < ($_POST["nom"] == $nom ? 2 : 1))
                { if
                  ( $this->env->data->set_groupe
                    ( $id,
                      $_POST["nom"],
                      $_POST["description"]
                    )
                  ) $this->env->redirect
                  ( $this->env->url("users/groupes"),
                    "le groupe a &eacute;t&eacute; modifi&eacute;"
                  );
                  else $this->env->erreur("Impossible de modifier le groupe");
                }
                else $this->env->message("Un groupe avec ce nom existe d&eacute;j&agrave;");
              }
              else $this->env->erreur("Impossible de savoir si le groupe existe d&eacute;j&agrave;");
            }
            else $this->env->message("merci de pr&eacute;ciser un nom pour le groupe");
          }
        }
        else $this->env->erreur("Impossible de lire les informations du groupe");
      }
      else $this->env->erreur("Impossible de creer le repertoire utilisateur");
    }

    function del()
    { if($this->env->data->del_groupe($this->groupe["id"]))
      { $this->env->redirect
        ( $this->env->url("users/groupes"),
          "le groupe a &eacute;t&eacute; supprim&eacute;"
        );
      }
      else $this->env->erreur("Impossible de supprimer le groupe");
    }

  }

?>