<?php

  class pz_env_init extends pz_env
  {

    function init()
    { $init_files = array();
      if(file_exists($init_path = $this->path("app").$this->path("core_app")."init/"))
      { if($dh = opendir($init_path))
        { $files = array();
          while(($file = readdir($dh)) !== false) $init_files[$file] = $init_path;
          closedir($dh);
          if(file_exists($init_path = $this->path("app").$this->path("current_app")."init/"))
          { if($dh = opendir($init_path))
            { $files = array();
              while(($file = readdir($dh)) !== false) $init_files[$file] = $init_path;
              closedir($dh);
            }
            else $this->erreur("impossible d'ouvrir le dossier init de l'application (current_app)", true);
          }
        }
        else $this->erreur("impossible d'ouvrir le dossier init de l'application (core_app)", true);
      }
      if($this->check_stop()) return;
      if($init_files)
      { ksort($init_files);
        foreach($init_files as $file => $init_path)
        { if($this->check_stop()) break;
          $this->run_init_file($init_path, $file);
        }
      }
    }

    function run_init_file($init_path, $file)
    { if
      (    strpos($file, "..") === false
        && !is_dir($init_path.$file)
        && strcmp(substr($file, -4), ".php") == 0
      ) require $init_path.$file;
    }

  }

?>