CREATE TABLE IF NOT EXISTS `pz_auteurs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_user` int(11) NOT NULL DEFAULT '0',
  `nom` varchar(255) NOT NULL DEFAULT '',
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `pz_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(11) DEFAULT NULL,
  `nom` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `pz_infos` (
  `element` varchar(255) NOT NULL DEFAULT '',
  `id_element` int(11) NOT NULL DEFAULT '0',
  `key` varchar(255) NOT NULL DEFAULT '',
  `value` text,
  PRIMARY KEY (`element`,`id_element`,`key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
INSERT INTO `pz_infos` (`element`, `id_element`, `key`, `value`) VALUES
('', 0, 'site_name', 'partazic'),
('', 0, 'max_list', '20');
CREATE TABLE IF NOT EXISTS `pz_licences` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nom` varchar(127) NOT NULL DEFAULT '',
  `url` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `pz_sources` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_auteur` int(11) DEFAULT NULL,
  `nom` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `licence` int(11) DEFAULT NULL,
  `reference` varchar(255) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `pz_source_categories` (
  `id_source` int(11) NOT NULL,
  `id_categorie` int(11) NOT NULL,
  PRIMARY KEY (`id_source`,`id_categorie`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE IF NOT EXISTS `pz_source_compositions` (
  `id_source` int(11) NOT NULL,
  `id_composition` int(11) NOT NULL,
  PRIMARY KEY (`id_source`,`id_composition`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE IF NOT EXISTS `pz_source_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nom` varchar(127) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
CREATE TABLE IF NOT EXISTS `pz_source_status_composition` (
  `id_source_status` int(11) NOT NULL,
  `id_source_status_composition` int(11) NOT NULL,
  `required` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_source_status`,`id_source_status_composition`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE IF NOT EXISTS `pz_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(63) NOT NULL,
  `password` varchar(127) NOT NULL,
  `email` varchar(127) NOT NULL,
  `status` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `login` (`login`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;
INSERT INTO `pz_users` (`id`, `login`, `password`, `email`, `status`) VALUES
(1, 'user', 'ee11cbb19052e40b07aac0ca060c23ee', 'user@domain.tld', 0);
CREATE TABLE IF NOT EXISTS `pz_user_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nom` varchar(127) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
