CREATE TABLE "pz_action_status" (
  "action" VARCHAR NOT NULL,
  "id_status" INTEGER NOT NULL,
  PRIMARY KEY ("action","id_status")
);
CREATE TABLE "pz_groupes" (
  "id" INTEGER NOT NULL,
  "id_user" INTEGER NOT NULL DEFAULT 0,
  "nom" VARCHAR NOT NULL DEFAULT '',
  "description" TEXT,
  PRIMARY KEY ("id")
);
CREATE TABLE "pz_categories" (
  "id" INTEGER NOT NULL,
  "parent" INTEGER DEFAULT NULL,
  "nom" VARCHAR DEFAULT NULL,
  "code" VARCHAR DEFAULT NULL,
  PRIMARY KEY ("id")
);
CREATE TABLE "pz_infos" (
  "element" VARCHAR NOT NULL DEFAULT '',
  "id_element" INTEGER NOT NULL DEFAULT '0',
  "key" VARCHAR NOT NULL DEFAULT '',
  "value" text,
  "type" VARCHAR DEFAULT NULL,
  PRIMARY KEY ("element","id_element","key")
);
INSERT INTO "pz_infos" VALUES ('', 0, 'site_name', 'partazic', NULL);
INSERT INTO "pz_infos" VALUES ('', 0, 'max_list', '20', NULL);
CREATE TABLE "pz_licences" (
  "id" INTEGER NOT NULL,
  "nom" VARCHAR NOT NULL DEFAULT '',
  "url" VARCHAR DEFAULT NULL,
  PRIMARY KEY ("id")
);
CREATE TABLE "pz_sources" (
  "id" INTEGER NOT NULL,
  "id_auteur" INTEGER DEFAULT NULL,
  "nom" VARCHAR DEFAULT NULL,
  "url" VARCHAR DEFAULT NULL,
  "licence" INTEGER DEFAULT NULL,
  "reference" VARCHAR DEFAULT NULL,
  "status" INTEGER DEFAULT NULL,
  PRIMARY KEY ("id")
);
CREATE TABLE "pz_source_categories" (
  "id_source" INTEGER NOT NULL,
  "id_categorie" INTEGER NOT NULL,
  PRIMARY KEY ("id_source","id_categorie")
);
CREATE TABLE "pz_source_compositions" (
  "id_source" INTEGER NOT NULL,
  "id_composition" INTEGER NOT NULL,
  PRIMARY KEY ("id_source","id_composition")
);
CREATE TABLE "pz_source_status" (
  "id" INTEGER NOT NULL,
  "nom" VARCHAR NOT NULL DEFAULT '',
  PRIMARY KEY ("id")
);
CREATE TABLE "pz_source_status_composition" (
  "id_source_status" INTEGER NOT NULL,
  "id_source_status_composition" INTEGER NOT NULL,
  "required" INTEGER NOT NULL DEFAULT '0',
  PRIMARY KEY ("id_source_status","id_source_status_composition")
);
CREATE TABLE "pz_users" (
  "id" INTEGER NOT NULL,
  "login" VARCHAR NOT NULL UNIQUE,
  "password" VARCHAR NOT NULL,
  "email" VARCHAR NOT NULL,
  "status" INTEGER NOT NULL DEFAULT '0',
  PRIMARY KEY ("id")
);
INSERT INTO "pz_users" VALUES (1, 'user', 'ee11cbb19052e40b07aac0ca060c23ee', 'user@domain.tld', 0);
CREATE TABLE "pz_user_status" (
  "id" INTEGER NOT NULL,
  "nom" VARCHAR NOT NULL DEFAULT '',
  PRIMARY KEY ("id")
);
